/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * main.c
 * Copyright (C) luzemail 2009 <luzem.dyndns.org>
 * 
 * Practica.1.ASO is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Practica.1.ASO is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 Escribir un programa en C que define una estructura de una listas enlazada single.	
 Este lista enlazada debe contener un campo entero, denominada “pid”, 
 y tambien un campo de tipo array estatica denominada mem[], representando algo no especificada.
 A continuación, escribe funciones que van a realizarlas siguientes operaciones fundamentales con este estructura:
 Va)	crear un elemento que inicializa cada uno de los campos
 Vb)	insertar un nuevo elemento al principio (a la cabecera) de la lista 
 Vc)	insertar un nuevo elemento al final (a la cola) de la lista 
 d)	un iterador que es capaz de imprimir cada uno de los campos de cada elmento y tambien
 imprime cada uno de los elementos del array estatica, mem[], correspondiente. 
 Ve)	Eliminar un elemento de la lista a traves del valor del pid
 */

//d <-- for debug


#include <stdio.h>
#include <malloc.h>
//NULL value defined in at line 147 "#include <stddef.h>"
#include <sys/types.h> 
//bool datatype http://en.wikipedia.org/wiki/Stdbool.h
#include <stdbool.h>



struct element
	{
		int pid; //identifier
		int mem[10];//memory pointer
		struct element *next; //next element in the list
	};

struct element *first; //first element of the list
struct element *last; //last element of the list

//Function Declaration
void initializeElement(struct element *elementInsert,int pid);
void insertAsFirst(struct element *elementInsert);
void insertAsLast(struct element *elementInsert);
void printElement(struct element *elementPrint);
void removeElement(int pidtoremove);
void copyelement(struct element *copied,struct element *source);
void sorlist();
void printList();

/**Set the default value to a element given*/
void initializeElement(struct element *elementInsert,int pid)
	{
	int x;
	elementInsert->pid=pid;
	elementInsert->next=NULL;//We don't know the next element address
	for (x=0;x<10;x++)
		{
		elementInsert->mem[x]=x;
		}
	}

/**Inserts a given element at the begin of the list*/
void insertAsFirst(struct element *elementInsert)
	{
	if (first==NULL) //First->NULL (empty list)
		{
		//First->NULL
		first = elementInsert;
		//First->elementInsert->NULL (elementInsert.next has NULL value by default function initializeElement)
		}
	else //List not empty
		{
		//First->|A|->|B|->|C|->..........->NULL
		//|ElementInsert|
		elementInsert->next=first;
		//First->|A|->|B|->|C|->..........->NULL
		//|ElementInsert|->|A|
		first=elementInsert;
		//First\                   ->|A|->|B|->|C|->..........->NULL
		//      ->|ElementInsert|/


		}
	}


/**Inserts a given element at the end of the list*/
void insertAsLast(struct element *elementInsert)
	{
	if (first==NULL) //Empty list
		{
		insertAsFirst (elementInsert);
		//d/printf("First==NULL\n");
		}
	else //list not empty
		{
		if (last==NULL) //list only have one element
			{
			first->next=elementInsert;
			last=elementInsert;
			//d/printf("First!=NULL last==NULL\n");
			//d/printf("Inside insertAsLast()  Last pointer to %p\n",last);
			}
		else //List with two or more elements
			{
			last->next=elementInsert;
			last=elementInsert;//replace last element
			//d/printf("First!=NULL last!=NULL\n");
			}
		}
	}

/**Prints the content of a given element*/
void printElement(struct element *elementPrint)
	{
	int x;
	printf("Element Address at %p ",elementPrint);
	printf("Element PID = %d \n",elementPrint->pid);
	for (x=0;x<10;x++)
		{
		//printf("Element n. %d value %d\n",x,elementPrint->mem[x]);
		}
	//d/printf("Next element at address  %p \n",elementPrint->next);
	}

void printList()
	{
	struct element *elementPrint;
	elementPrint=first;
	while(elementPrint!=NULL)
		{
		printf("%d-",elementPrint->pid);
		elementPrint=elementPrint->next;
		}
	printf("\n");
	//printf("Next element at address  %p \n",elementPrint->next);
	}


/**Removes the element where pid's number is the same of the given pid*/
void removeElement(int pidtoremove)
	{
	struct element *toremove;//element to remove
	struct element *beforeremove =NULL;//element that links toremove element
	toremove=first;//initialitation
	//search for a element's pid that value is the same 
	while (toremove!=NULL && toremove->pid!=pidtoremove)
		{
		beforeremove=toremove;
		toremove=toremove->next;
		//d/printf("In while pidtoremove %d element pid %d beforeremove = %p beforeremove->next %p toremove = %p\n",pidtoremove,toremove->pid,beforeremove,beforeremove->next,toremove);
		}
	if (toremove==NULL)
		{
		//d/printf("Element not found\n");
		}
	else
		{
		beforeremove->next = toremove->next;
		//d/free(toremove);
		printf("Element pid %d removed \n",pidtoremove);
		}
	}

//not the better way but the fastest
void copyelement(struct element *copied,struct element *source)
	{
	int x;
	copied->pid=source->pid;
	//copied->next=source->next;
	for (x=0;x<10;x++)
		{
		copied->mem[x]=source->mem[x];
		}
	}

//Short the list elements by pid
void sortlist()
	{
	bool change=true;
	struct element *firstelement=NULL;
	struct element *nextelement=NULL;
	struct element *tempelement=NULL;
	while(change) //if there are a element's change in the round the list isn't shorted
		{
		change=false;
		//Moving over the list
		firstelement=first;
		nextelement=first->next;
		while(nextelement->next!=NULL)
			{
			//Compare elements values
			printf("Comparing %d with %d\n",firstelement->pid,nextelement->pid);
			if (firstelement->pid>nextelement->pid)
				{
				//changue elements
				change=true;
		 	    tempelement=(struct element *) malloc (sizeof(struct element));
				copyelement (tempelement,firstelement);
				copyelement (firstelement,nextelement);
				copyelement (nextelement, tempelement);
				free(tempelement);
				printf("Elements Changued\n");
				printList();
				}
			firstelement=firstelement->next;
			nextelement=firstelement->next;
			}
		}
	}


int main (int argc, const char * argv[]) {
    // insert code here...
	//Initialize the list pointers
	first=NULL;
	last=NULL;
	//d/printf("List Initialized\n");
	int x;//counter
	struct element *temp;//temp struct for create the list's elements
	for (x=0;x<=25;x++)
		{
		temp=(struct element *) malloc (sizeof(struct element));//memory reservatión
		initializeElement(temp,x);
		//isert into the list unordened
		if (x%2==1)
			{
			insertAsFirst (temp);
			}
		else
			{
			insertAsLast (temp);
			}
		}
	struct element *forprint;//used for point the list elements one by one
	printf("Removing element\n");
	removeElement (8);
	sortlist ();
	forprint=first;//first element
	x=0;//check that the elements in the list 
	while (forprint->next!=NULL)
		{
		printElement (forprint);
		forprint=forprint->next;
		x++;
		}
    return 0;
	
}
